package org.jvnet.annox.model;

import org.jvnet.annox.model.XAnnotationField.XAnnotationArray;
import org.jvnet.annox.model.XAnnotationField.XBoolean;
import org.jvnet.annox.model.XAnnotationField.XBooleanArray;
import org.jvnet.annox.model.XAnnotationField.XByte;
import org.jvnet.annox.model.XAnnotationField.XByteArray;
import org.jvnet.annox.model.XAnnotationField.XChar;
import org.jvnet.annox.model.XAnnotationField.XCharArray;
import org.jvnet.annox.model.XAnnotationField.XClass;
import org.jvnet.annox.model.XAnnotationField.XClassArray;
import org.jvnet.annox.model.XAnnotationField.XDouble;
import org.jvnet.annox.model.XAnnotationField.XDoubleArray;
import org.jvnet.annox.model.XAnnotationField.XEnum;
import org.jvnet.annox.model.XAnnotationField.XEnumArray;
import org.jvnet.annox.model.XAnnotationField.XFloat;
import org.jvnet.annox.model.XAnnotationField.XFloatArray;
import org.jvnet.annox.model.XAnnotationField.XInt;
import org.jvnet.annox.model.XAnnotationField.XIntArray;
import org.jvnet.annox.model.XAnnotationField.XLong;
import org.jvnet.annox.model.XAnnotationField.XLongArray;
import org.jvnet.annox.model.XAnnotationField.XShort;
import org.jvnet.annox.model.XAnnotationField.XShortArray;
import org.jvnet.annox.model.XAnnotationField.XString;
import org.jvnet.annox.model.XAnnotationField.XStringArray;

public class XAnnotationVisitorWrapper<T> implements XAnnotationVisitor<T> {

	private final XAnnotationVisitor<T> annotationVisitor;

	public XAnnotationVisitor<T> getAnnotationVisitor() {
		return annotationVisitor;
	}

	public XAnnotationVisitorWrapper(XAnnotationVisitor<T> annotationVisitor) {
		this.annotationVisitor = annotationVisitor;
	}

	public T visitAnnotation(XAnnotation annotation) {
		return annotationVisitor.visitAnnotation(annotation);
	}

	public T visitAnnotationArrayField(XAnnotationArray field) {
		return annotationVisitor.visitAnnotationArrayField(field);
	}

	public T visitAnnotationField(
			org.jvnet.annox.model.XAnnotationField.XAnnotation field) {
		return annotationVisitor.visitAnnotationField(field);
	}

	public T visitBooleanArrayField(XBooleanArray field) {
		return annotationVisitor.visitBooleanArrayField(field);
	}

	public T visitBooleanField(XBoolean field) {
		return annotationVisitor.visitBooleanField(field);
	}

	public T visitByteArrayField(XByteArray field) {
		return annotationVisitor.visitByteArrayField(field);
	}

	public T visitByteField(XByte field) {
		return annotationVisitor.visitByteField(field);
	}

	public T visitCharArrayField(XCharArray field) {
		return annotationVisitor.visitCharArrayField(field);
	}

	public T visitCharField(XChar field) {
		return annotationVisitor.visitCharField(field);
	}

	public T visitClassArrayField(XClassArray field) {
		return annotationVisitor.visitClassArrayField(field);
	}

	public T visitClassField(XClass field) {
		return annotationVisitor.visitClassField(field);
	}

	public T visitDoubleArrayField(XDoubleArray field) {
		return annotationVisitor.visitDoubleArrayField(field);
	}

	public T visitDoubleField(XDouble field) {
		return annotationVisitor.visitDoubleField(field);
	}

	public T visitEnumArrayField(XEnumArray field) {
		return annotationVisitor.visitEnumArrayField(field);
	}

	public T visitEnumField(XEnum field) {
		return annotationVisitor.visitEnumField(field);
	}

	public T visitFloatArrayField(XFloatArray field) {
		return annotationVisitor.visitFloatArrayField(field);
	}

	public T visitFloatField(XFloat field) {
		return annotationVisitor.visitFloatField(field);
	}

	public T visitIntArrayField(XIntArray field) {
		return annotationVisitor.visitIntArrayField(field);
	}

	public T visitIntField(XInt field) {
		return annotationVisitor.visitIntField(field);
	}

	public T visitLongArrayField(XLongArray field) {
		return annotationVisitor.visitLongArrayField(field);
	}

	public T visitLongField(XLong field) {
		return annotationVisitor.visitLongField(field);
	}

	public T visitShortArrayField(XShortArray field) {
		return annotationVisitor.visitShortArrayField(field);
	}

	public T visitShortField(XShort field) {
		return annotationVisitor.visitShortField(field);
	}

	public T visitStringArrayField(XStringArray field) {
		return annotationVisitor.visitStringArrayField(field);
	}

	public T visitStringField(XString field) {
		return annotationVisitor.visitStringField(field);
	}

}
