package org.jvnet.annox.util;

public class ValueParseException extends Exception {

	private static final long serialVersionUID = 1L;

	private Class targetClass;

	private Object value;

	public ValueParseException(Object value, Class targetClass, Throwable cause) {
		super("Could not parse the value ["
				+ (value == null ? "null" : value.toString())
				+ "] into the target class ["
				+ (targetClass == null ? "null" : targetClass.getName()) + "].");
		this.targetClass = targetClass;
		this.value = value;
	}

	public Object getValue() {
		return value;
	}

	public Class getTargetClass() {
		return targetClass;
	}

}
